/* Sistemas Integrados TECNISA

Nome: 9900_RHMSTP_IMPORTPONTO.SQL

Descrio:
Verifica a coerncia dos registros de ponto vindos da catraca e CSA.

Criao:
05/05/2003 Giane Dolores de Melo
*/

CREATE OR REPLACE PROCEDURE IMPORTPONTO
  (P_CDEMPRESA    IN VARCHAR2,
   P_CDDEPTO      IN VARCHAR2,
   P_TCDDEPTO     IN VARCHAR2,
   P_CDFUNC       IN VARCHAR2,
   P_TCDFUNC      IN VARCHAR2,
   P_DTINI        IN DATE,
   P_DTFIN        IN DATE,
   P_NRSEQERROPTO IN VARCHAR2) IS

   V_NRSEQREGEPTO NUMBER;
   V_CDEMPRESA    VARCHAR2(02);
   V_CDFUNC       VARCHAR2(10);
   V_IDSENTIDO    VARCHAR2(01);
   V_DTBATIDA     DATE;

BEGIN
   V_NRSEQREGEPTO := 0;
   V_CDEMPRESA    := ' ';
   V_CDFUNC       := ' ';
   V_IDSENTIDO    := ' ';
   V_DTBATIDA     := SYSDATE;

   FOR C_PONTO IN
      (SELECT
          BA.CDEMPRESA,
          BA.CDFUNC,
          BA.DTBATIDAPTO,
          BA.IDSENTBATIDA,
          'B' TIPO
       FROM
          BATIDAPONTO BA,
          FUNCIONARIO FU
       WHERE
          BA.CDEMPRESA = P_CDEMPRESA                                  AND
          (BA.DTBATIDAPTO BETWEEN P_DTINI AND P_DTFIN)                AND
          ((INSTR(P_CDDEPTO, FU.CDDEPTO) <> 0) OR (P_TCDDEPTO = 'T')) AND
          ((INSTR(P_CDFUNC, BA.CDFUNC)   <> 0) OR (P_TCDFUNC  = 'T')) AND
          BA.CDEMPRESA = FU.CDEMPRESA                                 AND
          BA.CDFUNC    = FU.CDFUNC
       ORDER BY 
          CDEMPRESA,
          CDFUNC,
          DTBATIDAPTO)
   LOOP
      IF (V_CDEMPRESA <> C_PONTO.CDEMPRESA) OR (V_CDFUNC <> C_PONTO.CDFUNC) THEN
         V_CDEMPRESA := C_PONTO.CDEMPRESA;
         V_CDFUNC    := C_PONTO.CDFUNC;
         V_IDSENTIDO := C_PONTO.IDSENTBATIDA;
         V_DTBATIDA  := C_PONTO.DTBATIDAPTO;
      ELSE
         IF (V_IDSENTIDO = C_PONTO.IDSENTBATIDA) OR (V_DTBATIDA = C_PONTO.DTBATIDAPTO) THEN
            V_NRSEQREGEPTO := V_NRSEQREGEPTO + 1;
            INSERT INTO
               TRABERROPTO
                  (NRSEQREGEPTO,
                   NRSEQERROPTO,
                   CDEMPRESEPTO,
                   CDFUNCERRPTO,
                   DTBATIDAEPTO,
                   IDSENTIDEPTO,
                   IDTIPOPONTO)
               VALUES
                  (LPAD(TO_CHAR(V_NRSEQREGEPTO), 5, '0'),
                   P_NRSEQERROPTO,
                   C_PONTO.CDEMPRESA,
                   C_PONTO.CDFUNC,
                   C_PONTO.DTBATIDAPTO,
                   C_PONTO.IDSENTBATIDA,
                   C_PONTO.TIPO);
         END IF;
      END IF;
      V_IDSENTIDO := C_PONTO.IDSENTBATIDA;
      V_DTBATIDA  := C_PONTO.DTBATIDAPTO;
   END LOOP;
END;
/
